# **iBiz4j Spring R7 Template ChangeLog**

## [v2020.12.13]
- 支持工作流操作视图、操作表单配置
- 支持实体数据同步（RocketMQ）
- 支持工作流流程中状态值配置
- 支持父关系等价
- 支持属性值规则
- 支持界面行为多项数据主键
- 支持token续期
- 优化：补充接口实体服务接口鉴权
- 优化：动态数据源数据连接配置优化
- 优化：数据查询支持请求方式配置（默认为get，如：改为post）
- 优化：实体搜索项是否为空配置（搭配是否逻辑代码表使用）
- 优化：微服务部署中支持配置portmap将容器端口映射到主机端口（用于定时服务回调）
- 修复：服务接口返回状态码 response code
- 修复：实体行为、逻辑支持行为所有者配置

## [v2020.11.09]
- 支持属性重复值检查
- 支持引用组件包配置
- 支持定时任务中调用实体行为
- 修复serviceApi实体update脏检查处理
- 添加全局异常处理，数据库级异常补充errorKey
- 补充appData user扩展
- 系统预定义代码表推送RT

## [v2020.10.28]
- 修复虚拟联合主键模板错误
- 修复serviceApi实体数据导入外键值检查报错问题
- 补充静态代码表
- 支持实体关系中主实体删除（同步删除、限制删除、置空）等操作


## [v2020.10.17]
- 支持es查询加速:开启查询加速的实体，在完成标准实体存储之外，还会将一份数据存入es中，用于后续在es中进行检索。
- 兼容虚拟主键、多个联合键值属性类型不统一的问题。
- 补充联合主键中出现时间类型属性处理（时间类型属性默认按照yyyyMMddHHmmss格式处理）。
- 修复程序异常时，L1缓存值为空的问题。

## [v2020.09.22]
- 处理逻辑：支持处理逻辑中启动工作流
- **实体属性：模板全局属性javaType调整(请用户自行确认并同步调整USR代码)**
- 虚拟主键：支持虚拟主键，虚拟主键由联合键值构成，新建、更新、删除等操作均通过联合键值实现
- 值规则：支持非空、长度属性值规则校验（只在“新建”时校验）
- 实体对象：支持实体对象拷贝, entity.copyTo(entity2,true); 将entity对象值拷贝到entity2对象中，支持空值不拷贝(true/false) 
- RT：补充支付、通知、Lite 客户端配置
- 附加逻辑：支持实体行为附加实体行为配置
- 修复service填充父数据时，由于无法获取父数据而把父数据置空问题

## [v2020.09.06]
- 修复oracle数据库时间精度为毫秒导致版本检查异常问题
- 调整ou feign, 由ibz** 调整sys**
- 为AuthenticationUser添加相关注释

## [v2020.08.31]
- 消息集成:适配RT消息接口，通过钉钉、微信消息及短信等方式发送工作流待办消息
- 数据导入:批量数据采用异步方式进行导入，避免因数据量过大导致前端请求超时问题

## [v2020.08.18]

- 实体数据查询支持配置服务插件
- 工作流usertaskid与processkey不区分大小写
- 优化流程处理角色相关配置
- 标记工作流所在应用

## [v2020.08.10]
增强：
- 支持seata分布式事务
- 支持文件上传大小设置
- 支持动态代码表
- 支持表格无分页配置

优化：
- 修复子系统服务接口中台模式update空值问题
- 开启mysql批量更新设置


## [v2020.07.21]
增强：
- 数据查询:支持上下文的in查询
- 数据查询:支持无值忽略条件
- 支持实体数据导入

修复：
- 补充mapping别名，解决实体在多服务接口中，boot启动mapping重名问题
- 修复服务接口嵌套版本检查bug
- 附加逻辑添加逻辑所有者判断

## [v2020.07.14]
- 支持nacos.eureka服务注册中心，通过配置进行切换
- 支持serviceId动态化配置
- 支持mybatis-plus动态数据源
- 支持数据审计

## [v2020.07.02]
- 支持测试行为模式
- 数据保存时增加版本检查
- 调整Service扩展目录
- 补充数据查询上下级权限控制
- 关闭mybatis-plus分页数量大小限制